@echo off
set _STATUS=0
rem Script to re-register API Runtime binaries
echo.
set NETFXDIR=%SystemRoot%\Microsoft.NET\Framework
echo Checking UACelevated status of the script ...
echo.

whoami /groups | find "S-1-16-12288" > nul 
if "%errorlevel%"=="0" ( 
    	echo Running as elevated user.
	set ELEVATED=1
) else ( 
    	echo Not running as elevated user. 
	set ELEVATED=0
)

echo Checking architecture of current process ...
if defined ProgramFiles(x86) (
	echo Detected x64 platform
	set WOW6432NODE=Wow6432Node\
	if "%ProgramFiles(x86)%" EQU "%ProgramFiles%" (
		if %ELEVATED%==0 goto :RELAUNCH
		echo Running 32-bit cmd.exe - OK
		set SYS32DIR=%SystemRoot%\SysWOW64\
		set NETFX64DIR=%SystemRoot%\Microsoft.NET\Framework64
		goto :Register
	) else (
		echo 64 Bit cmd.exe. Relaunching in 32-bit cmd.exe
		pause
		goto :RELAUNCH
	)
) else (
	echo x86 platform
	set SYS32DIR=%SystemRoot%\System32\
	goto :Register
)


:Register
echo Directories ...
echo %SYS32DIR%
echo %NETFXDIR%
echo %NETFX64DIR%
echo %WOW6432NODE%
echo.
echo Getting install directory from Registry ...
For /F "skip=2 usebackq tokens=1,2,*" %%a in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\%WOW6432NODE%KVS\Enterprise Vault\API Runtime" /v InstallPath /t REG_SZ /s`) do (
	rem @echo %%a : %%b : %%c
	if "%%a"=="InstallPath" (
		echo Found installpath "%%c"
		set INSTALL_PATH=%%c
	)
)
if not defined INSTALL_PATH (
	set _STATUS=1
	goto :end
)
echo InstallPath = "%INSTALL_PATH%"
echo.
pause 

echo Registering COM DLLs
echo.
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%EVByteStream.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%IndexClient.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%EVSimpleAPI.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%VaultMessages.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%StorageOnlineOpnsps.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%DirectoryVaultU.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%EVPstApi.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%AutoStorageOnlineOpns.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%DirectoryConnectionU.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%DirectoryServiceps.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%IndexBrokerps.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%IndexServerps.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%EVContentManagementAPI.dll" /s
CALL :DoIt %SYS32DIR%\regsvr32.exe "%INSTALL_PATH%EVRetentionAPI.dll" /s

echo.
echo Registering x86 .Net DLLs
echo.
CALL :DoIt "%NETFXDIR%\v2.0.50727\RegAsm.exe"/tlb /codebase /verbose "%INSTALL_PATH%KVS.EnterpriseVault.NSFManager.dll"
CALL :DoIt "%NETFXDIR%\v2.0.50727\RegAsm.exe"/tlb /codebase /verbose "%INSTALL_PATH%KVS.EnterpriseVault.Common.dll"

echo.
echo Registering x64 .Net DLLs
echo.
if defined NETFX64DIR (
CALL :DoIt "%NETFX64DIR%\v2.0.50727\RegAsm.exe"/tlb /codebase /verbose "%INSTALL_PATH%KVS.EnterpriseVault.Runtime.dll"
CALL :DoIt "%NETFX64DIR%\v2.0.50727\RegAsm.exe"/tlb /codebase /verbose "%INSTALL_PATH%KVS.EnterpriseVault.TaskCommon.dll"
CALL :DoIt "%NETFX64DIR%\v2.0.50727\RegAsm.exe"/tlb /codebase /verbose "%INSTALL_PATH%KVS.EnterpriseVault.ProcessManagement.dll"

echo.
echo.
)

:End
if %_STATUS% EQU 1 (echo There were errors) else (echo Success)
echo.
pause
GOTO :EOF


:DoIt
echo Running command '%*'
%* || (
	echo ERROR executing '%*'
	set _STATUS=1
)
goto :EOF

:RELAUNCH
echo Relaunching
pause		
echo dim oShell: set oShell = Wscript.CreateObject("Shell.Application") > "%TEMP%\_LaunchElevated.vbs"
echo oShell.ShellExecute "%SystemRoot%\SysWOW64\cmd.exe", "/k %~0", "%~dp0","runas", 1 >> "%TEMP%\_LaunchElevated.vbs"
cscript //nologo "%TEMP%\_LaunchElevated.vbs"
goto :EOF



